--------------------------------------------------------------------------------
-- Copyright  2021								|
-- All Rights Reserved.								|
-- 										|
-- Permission to use, copy, modify, and distribute this software in any way	|
-- is not granted without expressed written agreement. This copyright applies	|
-- to the all code, data and artwork related to this project and all associated	|
-- projects published by the author.						|
--										|
-- More information on copyright is available from sources on-line.		|
-- Use an actual factual one!							|
--------------------------------------------------------------------------------

local addonName, NS = ...

local Lib = NS.FizzleLib

--------------------------- Nudge Slider -------------------------------------------------
local function NudgeSlider_OnClick(self, button)
	if button == "MiddleButton" then
		self.moving = nil
	else
		local parent = self:GetParent()
		local value = parent.Data[parent.Index]
		if (button == "RightButton") then
			value = value + self.bumpval
		elseif (self.moving) then
			value = value + self.glideval
		else
			value = value + self.nudgeval
		end
		parent.Data[parent.Index] = value
		Slider_Init(parent, parent.Data, parent.Index)
	end
end

local function CreateNudgeSlider(name, parent, nudgeval, bumpval, glideval, width, height)
	local f = Lib:CreateDefaultButton(name, parent, width, height)
	f:RegisterForClicks("LeftButtonUp", "RightButtonUp", "MiddleButtonUp")
	f.nudgeval = nudgeval
	f.bumpval = bumpval
	f.glideval = glideval
	f:SetScript("OnMouseDown", function(self, button)
			if button == "MiddleButton" then
				self.moving = true
			end
		end)
	f:SetScript("OnMouseUp", NudgeSlider_OnClick)
	f:SetScript("OnUpdate", function(self, elapsed)
			if not self.timer then
				self.timer = .05
			end
			self.timer = self.timer - elapsed
			if self.timer < 0 then
				self.timer = .05
				if self.moving then
					NudgeSlider_OnClick(self, button)
				end
			end
		end)
	return f
end
